
/************************************************************************/
/*                                                                      */
/*  Practica de Compiladors II                                          */
/*  Enginyeria en Informatica - Curs 2004 / 2005                        */
/*                                                                      */
/*  Fitxer pila.c: conté la definició del Tipus Abstracte de Dades Pila.*/
/*                                                                      */
/*  Autors: Sergio Blanco Cuaresma                                      */
/*          Francisco Jose Aguilar Celdran                              */
/*                                                                      */
/************************************************************************/

#define MODUL_PILA
#include <stdlib.h>
#include <stdio.h>
#include "pila.h"
    
/* --------------------------------- */
/* CREAR_PILA: Crea una nueva pila.  */
/* --------------------------------- */
         
Pila *crear_pila(void)
{
   Pila *nova;

   nova =(Pila *)malloc(sizeof(Pila));
   nova -> primer = NULL;
   nova -> ultim = NULL;
   nova -> pdi = NULL;   
   return nova;
}

/* ----------------------------------------------- */
/* PILA_BUIDA: respon si la pila esta o no buida.  */
/* ----------------------------------------------- */

unsigned int pila_buida(Pila *c)
{
   if(c -> primer == NULL) 
      return 1;
   else 
      return 0;
}

/* ----------------------------------------------------- */
/* ENPILAR: afegeix com a cim de la pila el node rebut.  */
/* ----------------------------------------------------- */

void enpilar(Pila *c, void *valors) //Cal linkar la TS anterior amb la seguent, millor que la pila no sigui generica
{
   Node_Pila *nou_node;
   
   nou_node = (Node_Pila *)malloc(sizeof(Node_Pila));
   nou_node -> node = valors;
   nou_node -> anterior = NULL;
   if (pila_buida(c))
   {
      c -> primer = nou_node;
      c -> ultim = nou_node;
      c -> pdi = nou_node;
   }
   else
   {
      nou_node -> anterior = c -> primer;
      c -> primer = nou_node;
   }
}

/* ------------------------------------------------------- */
/* DESENPILAR: elimina l'lement ubicat al cim de la pila.  */
/* ------------------------------------------------------- */

void desenpilar(Pila *c) //Cal eliminar la referencia a la TS seguent de la TS anterior, pensar-ho
{
   Node_Pila *aux;
   
   if (!pila_buida(c))
   {  
      if (c -> primer -> anterior == NULL)
      {
         c -> primer = NULL; 
         c -> ultim = NULL;
         c -> pdi = NULL;
      }  
      else
      {
         aux = c -> primer;
         c -> primer = c -> primer -> anterior;
         free(aux);
      }
   }
}

/* ------------------------------------------------------- */
/* CIM: retorna l'element que es troba al cim de la pila.  */
/* ------------------------------------------------------- */

void *cim(Pila *c)
{
   if (c -> primer != NULL)
      return c -> primer -> node;
   else
      return NULL;
}


