
/************************************************************************/
/*                                                                      */
/*  Practica de Compiladors II                                          */
/*  Enginyeria en Informatica - Curs 2004 / 2005                        */
/*                                                                      */
/*  Fitxer print_c3a.c: conté les funcionalitats necessaries per tal de */
/*                     mostrar en un fitxer el codi intermedi de tres   */
/*                     adreces corresponent a la correcta compilacio    */
/*                     del programa en MiniAda tractat pel compilador.  */
/*                     Per a cada ambit, es mostra la sequencia de      */
/*                     proposicions de tres adreces, evitant tallar     */
/*                     la impressio d'un ambit per mostrar el contingut */
/*                     d'un sub-ambit encaixat.                         */
/*                                                                      */
/*  Autors: Sergio Blanco Cuaresma                                      */
/*          Francisco Jose Aguilar Celdran                              */
/*                                                                      */
/************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "taula.h"
#include "comuns.h"

void print_codi_tres_adreces (FILE *output, Taula_Simbols *ts, char *str_ambit, int tipus_taula_simbols, int id_sobrecarrega, char *nom_unic) {
	int i;
	char aux[256];
	char ambit_aux[256];
	Simbol* simbol_derivat;
	
	if(ts != NULL)
	{
		
		if(tipus_taula_simbols == 0) {
			fprintf (output, "\n%s#------",str_ambit);
			for(i = 0; i < strlen(ts -> nom); i++) {
				fprintf (output, "-");
			}
			
			if (id_sobrecarrega != 0) {
				fprintf (output, "-----------------");
				fprintf (output, "\n%s#Ambit %s (sobrecarrega %d)\n",str_ambit,ts -> nom, id_sobrecarrega);
			} else {
				fprintf (output, "\n%s#Ambit %s\n",str_ambit,ts -> nom);
			}
			fprintf (output, "%s#------",str_ambit);
			for(i = 0; i < strlen(ts -> nom); i++) {
				fprintf (output, "-");
			}
			if (id_sobrecarrega != 0) {
				fprintf (output, "-----------------");
			}
			fprintf (output, "\n");
		}
				
		Simbol *simbol = busca_totes_taules(ts,ts -> nom);
				
		if(simbol != NULL) {
					
			Tipus_Simbol tipus = simbol -> atributs.tipus;
			if(tipus == PROCEDURE) {
				if(strcmp(nom_unic,"") != 0) {
					fprintf (output, "%s# Nom Complet: %s\n",str_ambit,nom_unic);
				}
			}
			else if(tipus == FUNCTION) {
				if(strcmp(nom_unic,"") != 0) {
					fprintf (output, "%s# Nom Complet: %s\n",str_ambit, nom_unic);		
				}
			}
			char ambit_aux[STRING_LENGTH];
			sprintf(ambit_aux,"%s# ",str_ambit);
			mostrar_procedencia(ts,ambit_aux,output);
						
			// Agafar la cua de sentencies que correspon a la funcio/procediment/sobrecarrega actual 
			Cua *cua_sentencies;
			
			if(tipus == PROCEDURE) {
				if (id_sobrecarrega != 0) {
					Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_procedure.sobrecarregues;
					reiniciar_PDI(cua_sobrecarregues);
					Info_Procedure *proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
					int count = 1;
					while (proc_actual != NULL) {
						if (id_sobrecarrega == count) {
							break;
						}
						
						count++;
						seguent_PDI(cua_sobrecarregues);
						proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
					}
					cua_sentencies = proc_actual->sentencies;
				} else {
					cua_sentencies = simbol -> sentencies;
				}
				
			} else if(tipus == FUNCTION) {
				if (id_sobrecarrega != 0) {
					Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_function.sobrecarregues;
					reiniciar_PDI(cua_sobrecarregues);
					Info_Function *proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
					int count = 1;					
					while (proc_actual != NULL) {
						if (id_sobrecarrega == count) {
							break;
						}
						
						count++;
						seguent_PDI(cua_sobrecarregues);
						proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
					}
					cua_sentencies = proc_actual->sentencies;
				} else {
					cua_sentencies = simbol -> sentencies;
				}
			}
			
			if(cua_sentencies != NULL) {
			
				fprintf (output, "%s# Representacio amb codi de tres adreces del codi intermig corresponent:\n",str_ambit);
				fprintf (output, "\n");
			
				reiniciar_PDI(cua_sentencies);
				Tipus_Sentencia *sentencia_actual = (Tipus_Sentencia *)obtenir_element_PDI(cua_sentencies);
				
				int comptador = 0;
				int sentencies_esborrades = 0;
				while (sentencia_actual != NULL) {
					//if (sentencia_actual -> esborrat == FALSE) {		
						Tipus_Operacio op = sentencia_actual -> operacio;
						char *arg1 = sentencia_actual -> arg1;
						char *arg2 = sentencia_actual -> arg2;
						char *arg3 = sentencia_actual -> arg3;
						comptador++;	
						
						// Al goto imprimirem també la tabulació
						if (op != GOTO) {
							fprintf(output,"%s",str_ambit);
						}

						switch(op) {
							case START:
								// arg1 es igual a NULL, omplim nosaltres amb el nom unic
								fprintf(output,"%d: START %s\n",comptador, nom_unic);
								break;
								
							case CHSI:
								fprintf(output,"%d: %s := CHSI %s\n",comptador,arg1,arg2);
								break;
								
							case CHSF:
								fprintf(output,"%d: %s := CHSF %s\n",comptador,arg1,arg2);
								break;
							
							case I2F:
								fprintf(output,"%d: %s := I2F %s\n",comptador,arg1,arg2);
								break;
								
							case F2I:
								fprintf(output,"%d: %s := F2I %s\n",comptador,arg1,arg2);
								break;
										
							case I2C:
								fprintf(output,"%d: %s := I2C %s\n",comptador,arg1,arg2);
								break;
								
							case C2I:
								fprintf(output,"%d: %s := C2I %s\n",comptador,arg1,arg2);
								break;
								
							case ADDI:
								fprintf(output,"%d: %s := %s ADDI %s\n",comptador,arg1,arg2,arg3);
								break;
								
							case SUBI:
								fprintf(output,"%d: %s := %s SUBI %s\n",comptador,arg1,arg2,arg3);
								break;
								
							case MULI:
								fprintf(output,"%d: %s := %s MULI %s\n",comptador,arg1,arg2,arg3);
								break;
								
							case DIVI:
								fprintf(output,"%d: %s := %s DIVI %s\n",comptador,arg1,arg2,arg3);
								break;
				
							case MODI:
								fprintf(output,"%d: %s := %s MODI %s\n",comptador,arg1,arg2,arg3);
								break;
								
							case ADDF:
								fprintf(output,"%d: %s := %s ADDF %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case SUBF:
								fprintf(output,"%d: %s := %s SUBF %s\n",comptador,arg1,arg2,arg3);
								break;
										
							case MULF:
								fprintf(output,"%d: %s := %s MULF %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case DIVF:
								fprintf(output,"%d: %s := %s DIVF %s\n",comptador,arg1,arg2,arg3);
								break;
							
							case ASSIGN:
								fprintf(output,"%d: %s := %s\n",comptador,arg1,arg2);
								break;
									
							case ASSIGN_TO_TABLE:
								fprintf(output,"%d: %s[%s] := %s\n",comptador,arg1,arg2,arg3);
								break;
							
							case ASSIGN_FROM_TABLE:
								fprintf(output,"%d: %s := %s[%s]\n",comptador,arg1,arg2,arg3);
								break;
									
							case GOTO:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg1, "%i", atoi(arg1) - sentencies_esborrades);

								// Si el GOTO ens porta a la linea seguent, aquest es pot eliminar
								/*if (atoi(arg1) == comptador + 1) {
									sentencies_esborrades++;
									comptador--;
									break;
								}*/
								
								fprintf(output,"%s",str_ambit);
								fprintf(output,"%d: GOTO %s\n",comptador,arg1);
								break;
							
							case IF_EQ:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s EQ %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case IF_NE:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s NE %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case IF_LTI:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s LTI %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case IF_LEI:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s LEI %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case IF_GTI:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s GTI %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
										
							case IF_GEI:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s GEI %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
								
							case IF_LTF:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s LTF %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
								
							case IF_LEF:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s LEF %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
							
							case IF_GTF:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s GTF %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case IF_GEF:
								// Reduim el salt tenint en compte que hi han hagut linies esborrades per optimitzacio
								sprintf(arg3, "%i", atoi(arg3) - sentencies_esborrades);
								fprintf(output,"%d: IF %s GEF %s GOTO %s\n",comptador,arg1,arg2,arg3);
								break;
									
							case PARAM:
								fprintf(output,"%d: PARAM %s\n",comptador,arg1);
								break;
									
							case CALL_FUNC:
								fprintf(output,"%d: %s := CALL %s,%s\n",comptador,arg1,arg2,arg3);
								break;
										
							case RETURN_FUNC:
								fprintf(output,"%d: RETURN %s\n",comptador,arg1);
								break;
									
							case CALL_PROC:
								fprintf(output,"%d: CALL %s,%s\n",comptador,arg1,arg2);
								break;
							
							case RETURN_PROC:
								fprintf(output,"%d: RETURN\n",comptador);
								break;
									
							case PUTC:
								fprintf(output,"%d: call PUTC,1\n",comptador);
								break;
									
							case PUTI:
								fprintf(output,"%d: call PUTI,1\n",comptador);
								break;
							
							case PUTF:
								fprintf(output,"%d: call PUTF,1\n",comptador);
								break;	
								
							case GETC:
								fprintf(output,"%d: %s := call GETC,0\n",comptador, arg1);
								break;
				
							case GETI:
								fprintf(output,"%d: %s := call GETI,0\n",comptador, arg1);
								break;
	
							case GETF:
								fprintf(output,"%d: %s := call GETF,0\n",comptador, arg1);
								break;
				
							case HALT:
								fprintf(output,"%d: HALT\n",comptador);
								break;
				
							default:
								break;
						}	
					/*} else {
						sentencies_esborrades++;
					}*/
							
					seguent_PDI(cua_sentencies);
					sentencia_actual = (Tipus_Sentencia *)obtenir_element_PDI(cua_sentencies);
				}
				fprintf(output,"\n");
			}	
		}
		for (i = 0; i < TAM_TAULA_SIMBOLS; i++) {
			if (ts->taula[i] != NULL) {
				Cua *colisions = ts -> taula[i];
				reiniciar_PDI(colisions);
				Simbol *simbol = (Simbol *)obtenir_element_PDI(colisions);
				while(simbol != NULL) {
	
					// EL SIMBOL ES UN PROCEDIMENT
				
					if (simbol->atributs.tipus == PROCEDURE) {
						sprintf(ambit_aux,"%s    ",str_ambit);
					
						print_codi_tres_adreces (output, simbol -> atributs.continguts.info_procedure.taula,ambit_aux,0,0, simbol -> atributs.continguts.info_procedure.nom_unic);
						fprintf (output, "\n");
						
						int num_sobrecarregues = simbol->atributs.continguts.info_procedure.num_sobrecarregues;
						if (num_sobrecarregues != 0) {
							Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_procedure.sobrecarregues;
							reiniciar_PDI(cua_sobrecarregues);
							Info_Procedure *proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
													
							while (proc_actual != NULL) {
								print_codi_tres_adreces (output, proc_actual -> taula,ambit_aux,0, proc_actual -> id, proc_actual->nom_unic);
								fprintf (output, "\n");
								
								seguent_PDI(cua_sobrecarregues);
								proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
							}
						}
					}
		
					// EL SIMBOL ES UNA FUNCIO
				
					if (simbol->atributs.tipus == FUNCTION){
						sprintf(ambit_aux,"%s    ",str_ambit);
							
						print_codi_tres_adreces (output, simbol -> atributs.continguts.info_function.taula,ambit_aux,0,0, simbol -> atributs.continguts.info_function.nom_unic);
						fprintf (output, "\n");
				
						int num_sobrecarregues = simbol->atributs.continguts.info_function.num_sobrecarregues;
						if (num_sobrecarregues != 0) {
							Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_function.sobrecarregues;
							reiniciar_PDI(cua_sobrecarregues);
							Info_Function *proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
												
							while (proc_actual != NULL) {
								print_codi_tres_adreces (output, proc_actual -> taula,ambit_aux,0,proc_actual -> id, proc_actual -> nom_unic);
								fprintf (output, "\n");
								
								seguent_PDI(cua_sobrecarregues);
								proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
							}
						}				
					}
		
					seguent_PDI(colisions);
					simbol = (Simbol *)obtenir_element_PDI(colisions);
				}
			}
		}
	}
	else
	{
		fprintf (output, "\t Aquesta taula de simbols no te cap contingut.\n\n");	
	}
}	



