
/************************************************************************/
/*                                                                      */
/*  Practica de Compiladors II                                          */
/*  Enginyeria en Informatica - Curs 2004 / 2005                        */
/*                                                                      */
/*  Fitxer print_ra.c: conté les funcionalitats necessaries per tal de  */
/*                     generar i mostrar en un fitxer del contingut de  */
/*                     tots els Registres d'Activacio obtinguts de la   */
/*                     compilacio. Es calcula el tamany de tots els     */
/*                     tipus de la TS i es mante un comptador d'adreça  */
/*                     de memoria, acumulat per al calcul de valor de   */
/*                     retorn, parametres formals, variables locals i   */
/*                     variables temporals. No s'interromp la impressio */
/*                     d'un RA per mostrar el contingut d'un altre RA.  */
/*                                                                      */
/*  Autors: Sergio Blanco Cuaresma                                      */
/*          Francisco Jose Aguilar Celdran                              */
/*                                                                      */
/************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "taula.h"
#include "print_ra.h"
#include "comuns.h"
#include "cua.h"

void construir_registre_activacio(Tipus_Simbol tipus_simbol, int num_parametres, Cua *parametres, Tipus_Dades tipus_retorn, char *nom_tipus_retorn, Cua *variables_locals, Cua *variables_temporals, FILE *output, Taula_Simbols *taula_local, Taula_Simbols *taula_actual);
int obtenir_tamany_record(Simbol *record, Taula_Simbols *taula_actual);
int obtenir_tamany_array(Simbol *array, Taula_Simbols *taula_actual);
int calcular_tamany_tipus(Taula_Simbols *taula_actual, char *nom_tipus_derivat);
void imprimir_cadena_sortida(char *cadena_sortida, int tamany_linia_RA, FILE *output);

void print_registres_activacio (FILE *output, Taula_Simbols *ts, char *str_ambit, int tipus_taula_simbols, int id_sobrecarrega) {
	int i;
	char aux[256];
	char ambit_adicional[STRING_LENGTH];
	Simbol* simbol_derivat;
	
	if(ts != NULL)
	{
		
		if(tipus_taula_simbols == 0) {
			fprintf (output, "\n%s#------",str_ambit);
			for(i = 0; i < strlen(ts -> nom); i++) {
				fprintf (output, "-");
			}
			
			if (id_sobrecarrega != 0) {
				fprintf (output, "-----------------");
				fprintf (output, "\n%s#Ambit %s (sobrecarrega %d)\n",str_ambit,ts -> nom, id_sobrecarrega);
			} else {
				fprintf (output, "\n%s#Ambit %s\n",str_ambit,ts -> nom);
			}
			fprintf (output, "%s#------",str_ambit);
			for(i = 0; i < strlen(ts -> nom); i++) {
				fprintf (output, "-");
			}
			if (id_sobrecarrega != 0) {
				fprintf (output, "-----------------");
			}
			fprintf (output, "\n");
		}
				
		Simbol *simbol = busca_totes_taules(ts,ts -> nom);
				
		if(simbol != NULL) {
					
			Tipus_Simbol tipus = simbol -> atributs.tipus;
			
			Cua *parametres;
			int num_parametres;
			Tipus_Dades tipus_retorn;
			char *nom_tipus_retorn; 
			Cua *variables_locals;
			Cua *variables_temporals;
			Taula_Simbols *taula_local;
																		
			if(tipus == PROCEDURE) {
				if(strcmp(simbol -> atributs.continguts.info_procedure.nom_unic,"") != 0) {
					fprintf (output, "%sNom Complet: %s\n",str_ambit,simbol -> atributs.continguts.info_procedure.nom_unic);
					parametres = simbol -> atributs.continguts.info_procedure.parametres;
					num_parametres = simbol -> atributs.continguts.info_procedure.num_parametres;
					variables_locals = simbol -> atributs.continguts.info_procedure.variables_locals;
					variables_temporals = simbol -> atributs.continguts.info_procedure.variables_temporals;
					taula_local = simbol -> atributs.continguts.info_procedure.taula;
				}
			}
			else if(tipus == FUNCTION) {
				if(strcmp(simbol -> atributs.continguts.info_function.nom_unic,"") != 0) {
					fprintf (output, "%sNom Complet: %s\n",str_ambit,simbol -> atributs.continguts.info_function.nom_unic);
					parametres = simbol -> atributs.continguts.info_function.parametres;
					num_parametres = simbol -> atributs.continguts.info_function.num_parametres;
					variables_locals = simbol -> atributs.continguts.info_function.variables_locals;
					variables_temporals = simbol -> atributs.continguts.info_function.variables_temporals;
					tipus_retorn = simbol -> atributs.continguts.info_function.tipus_retorn;
					nom_tipus_retorn = simbol -> atributs.continguts.info_function.nom_tipus_retorn;
					taula_local = simbol -> atributs.continguts.info_function.taula;
				}
			}
			mostrar_procedencia(ts,str_ambit,output);
			fprintf(output,"\n");
			
			construir_registre_activacio(tipus, num_parametres, parametres, tipus_retorn, nom_tipus_retorn, variables_locals, variables_temporals, output,taula_local,ts);
			
		}
		for (i = 0; i < TAM_TAULA_SIMBOLS; i++) {
			if (ts->taula[i] != NULL) {
				Cua *colisions = ts -> taula[i];
				reiniciar_PDI(colisions);
				Simbol *simbol = (Simbol *)obtenir_element_PDI(colisions);
				while(simbol != NULL) {
	
					// EL SIMBOL ES UN PROCEDIMENT
				
					if (simbol->atributs.tipus == PROCEDURE) {
						sprintf(ambit_adicional,"%s    ",str_ambit);
					
						print_registres_activacio (output, simbol -> atributs.continguts.info_function.taula,ambit_adicional,0,0);
						//fprintf (output, "\n");
						
						int num_sobrecarregues = simbol->atributs.continguts.info_procedure.num_sobrecarregues;
						if (num_sobrecarregues != 0) {
							Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_procedure.sobrecarregues;
							reiniciar_PDI(cua_sobrecarregues);
							Info_Procedure *proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
													
							while (proc_actual != NULL) {
								print_registres_activacio (output, proc_actual -> taula,ambit_adicional,0, proc_actual -> id);
								//fprintf (output, "\n");
								
								seguent_PDI(cua_sobrecarregues);
								proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
							}
						}
					}
		
					// EL SIMBOL ES UNA FUNCIO
				
					if (simbol->atributs.tipus == FUNCTION){
						sprintf(ambit_adicional,"%s    ",str_ambit);
							
						print_registres_activacio (output, simbol -> atributs.continguts.info_function.taula,ambit_adicional,0,0);
						//fprintf (output, "\n");
				
						int num_sobrecarregues = simbol->atributs.continguts.info_function.num_sobrecarregues;
						if (num_sobrecarregues != 0) {
							Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_function.sobrecarregues;
							reiniciar_PDI(cua_sobrecarregues);
							Info_Function *proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
												
							while (proc_actual != NULL) {
								print_registres_activacio (output, proc_actual -> taula,ambit_adicional,0,proc_actual -> id);
								//fprintf (output, "\n");
								
								seguent_PDI(cua_sobrecarregues);
								proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
							}
						}				
					}
		
					seguent_PDI(colisions);
					simbol = (Simbol *)obtenir_element_PDI(colisions);
				}
			}
		}
	}
	else
	{
		fprintf (output, "\t Aquesta taula de simbols no te cap contingut.\n\n");	
	}
}

// Metode que mostra per la sortida indicada per parametre totes les dades del registre d'activacio corresponent 
// a la taula de simbols rebuda.
void construir_registre_activacio(Tipus_Simbol tipus_simbol, int num_parametres, Cua *parametres, Tipus_Dades tipus_retorn, char *nom_tipus_retorn, Cua *variables_locals, Cua *variables_temporals, FILE *output, Taula_Simbols *taula_local, Taula_Simbols *taula_actual) 
{
	int comptadorRA = 0;
	char cadena_sortida[STRING_LENGTH];
	int tamany_linia_RA = 71;

	fprintf(output,"| --------------------------------------------------------------------- |\n");
	fprintf(output,"|                        REGISTRE  D'ACTIVACIO                          |\n");
	fprintf(output,"| --------------------------------------------------------------------- |\n");
	fprintf(output,"|    * Valor de Retorn:                                                 |\n");

	char espai[10] = "     	  ";

	if(tipus_simbol == PROCEDURE) {
		fprintf(output,"|%stipus_buit                                                    |\n",espai);
	}
	else {
		int tamany_tipus;
		switch(tipus_retorn)
		{
			case TIPUS_INTEGER:
				sprintf (cadena_sortida, "|%s(%d): tipus: integer, tamany: 2", espai, comptadorRA);
				comptadorRA += 2;
				break;
			case TIPUS_FLOAT: 
				sprintf (cadena_sortida, "%|s(%d): tipus: float, tamany: 4", espai, comptadorRA);
				comptadorRA += 4;
				break;
			case TIPUS_BOOLEAN:	
				sprintf (cadena_sortida, "|%s(%d): tipus: boolean, tamany: 1", espai, comptadorRA);
				comptadorRA += 1;
				break;
			case TIPUS_CHARACTER: 
				sprintf (cadena_sortida, "|%s(%d): tipus: character, tamany: 1", espai, comptadorRA);
				comptadorRA += 1;
				break;
			case TIPUS_STRING: 
				sprintf (cadena_sortida, "|%s(%d): tipus: string, tamany: 256", espai, comptadorRA);
				comptadorRA += 256;
				break;
			case TIPUS_DERIVAT:
				tamany_tipus = calcular_tamany_tipus(taula_actual, nom_tipus_retorn);
				sprintf (cadena_sortida, "|%s(%d): tipus: derivat, %s, tamany: %d", espai, comptadorRA, nom_tipus_retorn, tamany_tipus);
				comptadorRA += tamany_tipus; 
				break;
			case TIPUS_INTEGER_DERIVAT:	
				sprintf (cadena_sortida, "%s(%d): tipus: integer_derivat, tamany: 2", espai, comptadorRA);
				comptadorRA += 2; 
				break;
			default:
				sprintf (cadena_sortida, "%s(tipus desconegut)", espai);
				break;
		}
		imprimir_cadena_sortida(cadena_sortida, tamany_linia_RA, output);
	}     
	fprintf(output,"|                            ---------------                            |\n");
	fprintf(output,"|    * Parametres Formals:                                              |\n");
	
	if(parametres != NULL) {
		reiniciar_PDI(parametres);
		char *nom_parametre = (char *)obtenir_element_PDI(parametres);
		while(nom_parametre != NULL)
		{
			Simbol *element = obtenir_simbol(taula_local, nom_parametre);
			char *nom_tipus_derivat;
			int tamany_tipus;
			switch(element -> atributs.continguts.info_variable.tipus)
			{
				case TIPUS_INTEGER:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: integer, tamany: 2", espai, comptadorRA, element -> nom);
					comptadorRA += 2;
					break;
				case TIPUS_FLOAT: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: float, tamany: 4", espai, comptadorRA, element -> nom);
					comptadorRA += 4;
					break;
				case TIPUS_BOOLEAN:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: boolean, tamany: 1", espai, comptadorRA, element -> nom);
					comptadorRA += 1;
					break;
				case TIPUS_CHARACTER: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: character, tamany: 1", espai, comptadorRA, element -> nom);
					comptadorRA += 1;
					break;
				case TIPUS_STRING: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: string, tamany: 256", espai, comptadorRA, element -> nom);
					comptadorRA += 256;
					break;
				case TIPUS_DERIVAT:
					nom_tipus_derivat = element -> atributs.continguts.info_variable.nom_tipus;
					tamany_tipus = calcular_tamany_tipus(taula_actual, nom_tipus_derivat);
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: derivat, %s, tamany: %d", espai, comptadorRA, element -> nom, nom_tipus_derivat, tamany_tipus); 
					comptadorRA += tamany_tipus;
					break;
				case TIPUS_INTEGER_DERIVAT:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: integer_derivat, tamany: 2", espai, comptadorRA, element -> nom);
					comptadorRA += 2;
					break;
			}
			imprimir_cadena_sortida(cadena_sortida, tamany_linia_RA, output);
			seguent_PDI(parametres);
			nom_parametre = (char*)obtenir_element_PDI(parametres);
		}
	}
	else {
		fprintf(output,"|%sNo hi ha parametres.                                          |\n",espai);
	}
	
	fprintf(output,"| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |\n");
	fprintf(output,"|    Enllac de Control   |   Enllac d'Acces   |   Estat de la Maquina   |\n");
	fprintf(output,"| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |\n");
	fprintf(output,"|    * Dades Locals:                                                    |\n");
	if(variables_locals != NULL) {
		reiniciar_PDI(variables_locals);
		Simbol *var_local = (Simbol *)obtenir_element_PDI(variables_locals);
		if(var_local == NULL) {
			fprintf(output,"|%sNo hi ha variables locals.                                    |\n",espai);
		}
		while(var_local != NULL)
		{
			char *nom_tipus_derivat;
			int tamany_tipus;
			switch(var_local -> atributs.continguts.info_variable.tipus)
			{
				case TIPUS_INTEGER:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: integer, tamany: 2", espai, comptadorRA, var_local -> nom);
					comptadorRA += 2;
					break;
				case TIPUS_FLOAT: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: float, tamany: 4", espai, comptadorRA, var_local -> nom);
					comptadorRA += 4;
					break;
				case TIPUS_BOOLEAN:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: boolean, tamany: 1", espai, comptadorRA, var_local -> nom);
					comptadorRA += 1;
					break;
				case TIPUS_CHARACTER: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: character, tamany: 1", espai, comptadorRA, var_local -> nom);
					comptadorRA += 1;
					break;
				case TIPUS_STRING: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: string, tamany: 256", espai, comptadorRA, var_local -> nom);
					comptadorRA += 256;
					break;
				case TIPUS_DERIVAT:
					nom_tipus_derivat = var_local -> atributs.continguts.info_variable.nom_tipus;
					tamany_tipus = calcular_tamany_tipus(taula_actual, nom_tipus_derivat);
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: derivat, %s, tamany: %d", espai, comptadorRA, var_local -> nom, nom_tipus_derivat, tamany_tipus); 
					comptadorRA += tamany_tipus;
					break;
				case TIPUS_INTEGER_DERIVAT:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: integer_derivat, tamany: 2", espai, comptadorRA, var_local -> nom);
					comptadorRA += 2;
					break;
					
			}
			imprimir_cadena_sortida(cadena_sortida, tamany_linia_RA, output);
			seguent_PDI(variables_locals);
			var_local = (Simbol *)obtenir_element_PDI(variables_locals);
		}
	}
	else {
		fprintf(output,"|%sNo hi ha variables locals.                                     |\n",espai);
	}

	fprintf(output,"|                            ---------------                            |\n");
	fprintf(output,"|    * Dades Temporals:                                                 |\n");
	if(variables_temporals != NULL) {
		reiniciar_PDI(variables_temporals);
		
		Simbol *var_temporal = (Simbol *)obtenir_element_PDI(variables_temporals);
		if(var_temporal == NULL) {
			fprintf(output,"|%sNo hi ha variables temporals!                                 |\n",espai);
		}
		while(var_temporal != NULL)
		{
		
			sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: integer, tamany: 2", espai, comptadorRA, var_temporal->nom);
			char *nom_tipus_derivat;
			int tamany_tipus;
			
			switch(var_temporal -> atributs.continguts.info_variable.tipus)
			{
				case TIPUS_INTEGER:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: integer, tamany: 2", espai, comptadorRA, var_temporal -> nom);
					comptadorRA += 2;
					break;
				case TIPUS_FLOAT: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: float, tamany: 4", espai, comptadorRA, var_temporal -> nom);
					comptadorRA += 4;
					break;
				case TIPUS_BOOLEAN:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: boolean, tamany: 1", espai, comptadorRA, var_temporal -> nom);
					comptadorRA += 1;
					break;
				case TIPUS_CHARACTER: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: character, tamany: 1", espai, comptadorRA, var_temporal -> nom);
					comptadorRA += 1;
					break;
				case TIPUS_STRING: 
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: string, tamany: 256", espai, comptadorRA, var_temporal -> nom);
					comptadorRA += 256;
					break;
				case TIPUS_DERIVAT:
					nom_tipus_derivat = var_temporal -> atributs.continguts.info_variable.nom_tipus;
					tamany_tipus = calcular_tamany_tipus(taula_actual, nom_tipus_derivat);
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: derivat, %s, tamany: %d", espai, comptadorRA, var_temporal -> nom, nom_tipus_derivat, tamany_tipus); 
					comptadorRA += tamany_tipus;
					break;
				case TIPUS_INTEGER_DERIVAT:	
					sprintf (cadena_sortida, "|%s(%d): nom: %s, tipus: integer_derivat, tamany: 2", espai, comptadorRA, var_temporal -> nom);
					comptadorRA += 2;
					break;
					
			}
			
			imprimir_cadena_sortida(cadena_sortida, tamany_linia_RA, output);
			seguent_PDI(variables_temporals);
			var_temporal = (Simbol *)obtenir_element_PDI(variables_temporals);
		}
	}
	else {
		fprintf(output,"|%sNo hi ha variables temporals.                                 |\n",espai);
	}
	
	fprintf(output,"| --------------------------------------------------------------------- |\n");
	sprintf(cadena_sortida,"|  Fi del Registre d'Activacio de l'ambit %s",taula_actual -> nom);
	imprimir_cadena_sortida(cadena_sortida, tamany_linia_RA + 1, output);
	fprintf(output,"| --------------------------------------------------------------------- |\n");

}

// Metode que obte el tamany de un tipus derivat calculant recursivament per a tots 
//els seus elements els bytes totals ocupats.
int calcular_tamany_tipus(Taula_Simbols *taula_actual, char *nom_tipus_derivat)
{
	int tamany_simbol = 0;

	Simbol *simbol_tipus = (Simbol *)busca_totes_taules(taula_actual, nom_tipus_derivat);
	Tipus_Simbol tipus_actual = simbol_tipus -> atributs.tipus;
	if(tipus_actual == RECORD_TYPE) {
		// Calcul del tamany en bytes del record
		tamany_simbol = obtenir_tamany_record(simbol_tipus, taula_actual);
	}
	else if (tipus_actual == ARRAY_TYPE){
		// Calcul del tamany en bytes de l'array
		tamany_simbol = obtenir_tamany_array(simbol_tipus, taula_actual);
	}
	else if (tipus_actual == ENUMERATED_TYPE) {
		// Els enumerats ocupen un byte
		tamany_simbol = 1;
	}
	return tamany_simbol;
}

// Metode que calcula el tamany ocupat pel record especificat.
int obtenir_tamany_record(Simbol *record, Taula_Simbols *taula_actual)
{
	int tamany_record = 0;
	int i = 0;
	Info_Record info = record -> atributs.continguts.info_record;
	Taula_Simbols *elements = info.elements;
	
	for (i = 0; i < TAM_TAULA_SIMBOLS; i++) {
		if (elements -> taula[i] != NULL) {
			Cua colisions_copia;
			memcpy(&colisions_copia, elements -> taula[i], sizeof(Cua));
			Cua *colisions = &colisions_copia;
			reiniciar_PDI(colisions);
			Simbol *element = (Simbol *)obtenir_element_PDI(colisions);
			while(element != NULL) {
				Tipus_Simbol tipus_elem = element -> atributs.tipus;
				if(tipus_elem == VARIABLE) {
					char *nom_tipus_derivat;
					Info_Variable *dades = &(element -> atributs.continguts.info_variable);
					Tipus_Dades tipus_variable = dades -> tipus;
					switch(tipus_variable)
					{
						case TIPUS_INTEGER:
							tamany_record += 2;
							break;
						case TIPUS_INTEGER_DERIVAT:
							tamany_record += 2;
							break;
						case TIPUS_FLOAT:
							tamany_record += 4; 
							break;
						case TIPUS_BOOLEAN:
							tamany_record += 1;
							break;
						case TIPUS_CHARACTER:
							tamany_record += 1;
							break;
						case TIPUS_STRING:
							tamany_record += 256;
							break;	
						case TIPUS_DERIVAT:
							nom_tipus_derivat = dades -> nom_tipus;
							tamany_record += calcular_tamany_tipus(taula_actual,nom_tipus_derivat);
							break;
					}
					seguent_PDI(colisions);
					element = (Simbol *)obtenir_element_PDI(colisions);
				}
			}
		}
	}		
	return tamany_record;
}

// Metode que calcula el tamany ocupat pel record especificat.
int obtenir_offset_fins_element_record(Simbol *record, char *nom_element, Taula_Simbols *taula_actual)
{
	int offset = 0;

	Cua *llista_elements = record->atributs.continguts.info_record.llista_elements;
	
	reiniciar_PDI(llista_elements);
	Simbol *element = (Simbol *)obtenir_element_PDI(llista_elements);
	while(element != NULL) {
		if (strcmp(element->nom, nom_element) == 0) {
			return offset;
		}
		Tipus_Simbol tipus_elem = element -> atributs.tipus;
		if(tipus_elem == VARIABLE) {
			char *nom_tipus_derivat;
			Info_Variable *dades = &(element -> atributs.continguts.info_variable);
			Tipus_Dades tipus_variable = dades -> tipus;
			switch(tipus_variable)
			{
				case TIPUS_INTEGER:
					offset += 2;
					break;
				case TIPUS_INTEGER_DERIVAT:
					offset += 2;
					break;
				case TIPUS_FLOAT:
					offset += 4; 
					break;
				case TIPUS_BOOLEAN:
					offset += 1;
					break;
				case TIPUS_CHARACTER:
					offset += 1;
					break;
				case TIPUS_STRING:
					offset += 256;
					break;	
				case TIPUS_DERIVAT:
					nom_tipus_derivat = dades -> nom_tipus;
					offset += calcular_tamany_tipus(taula_actual, nom_tipus_derivat);
					break;
			}
			seguent_PDI(llista_elements);
			element = (Simbol *)obtenir_element_PDI(llista_elements);
		}
	}		
	return offset;
}

// Metode que calcula el tamany ocupat per l'array especificat.
int obtenir_tamany_array(Simbol *array, Taula_Simbols *taula_actual)
{
	int tamany_array = 0;
	Info_Array *info = &(array -> atributs.continguts.info_array);
	Tipus_Dades tipus = info -> tipus;
	Rang rang_array = info -> rang;
	int num_elems = (rang_array.max - rang_array.min) + 1;
	char *nom_tipus_derivat;
	switch(tipus)
	{
		case TIPUS_INTEGER:
			tamany_array = 2 * num_elems;
			break;
		case TIPUS_INTEGER_DERIVAT:
			tamany_array = 2 * num_elems;
			break;
		case TIPUS_FLOAT:
			tamany_array = 4 * num_elems; 
			break;
		case TIPUS_BOOLEAN:
			tamany_array = 1 * num_elems;
			break;
		case TIPUS_CHARACTER:
			tamany_array = 1 * num_elems;
			break;
		case TIPUS_STRING:
			tamany_array = 256 * num_elems;
			break;	
		case TIPUS_DERIVAT:
			nom_tipus_derivat = info -> nom_tipus;
			tamany_array = calcular_tamany_tipus(taula_actual,nom_tipus_derivat) * num_elems;
			break;
	}
	return tamany_array;
}

// Metode que mostra per pantalla la cadena passada per parametre, completant-la amb la longitud
// adequada per a que es visualitzi per pantalla la linia actual amb el mateix format que el
// tamany del registre d'activació.
void imprimir_cadena_sortida(char *cadena_sortida, int tamany_linia_RA, FILE *output)
{
	int tamany = strlen(cadena_sortida);
	fprintf(output, "%s", cadena_sortida);
	while(tamany < tamany_linia_RA) {
		fprintf(output, " ");
		tamany++;
	}
	fprintf(output, "|\n");
}

// Obte el tamany d'un tipus basic
int obtenir_tamany_tipus_basic (Tipus_Dades tipus_variable) {
	switch(tipus_variable)
	{
		case TIPUS_INTEGER:
		case TIPUS_INTEGER_DERIVAT:
			return 2;
			break;
		case TIPUS_FLOAT:
			return 4; 
			break;
		case TIPUS_BOOLEAN:
		case TIPUS_CHARACTER:
			return 1;
		case TIPUS_STRING:
			return 256;
			break;	
	}
}

