
/************************************************************************/
/*                                                                      */
/*  Practica de Compiladors II                                          */
/*  Enginyeria en Informatica - Curs 2004 / 2005                        */
/*                                                                      */
/*  Fitxer print_ts.c: s'encarrega de mostrar en un fitxer de sortida   */
/*                     el contingut complet de la Taula de Simbols.     */
/*                     Es tracten recursivament tots els ambits i no    */
/*                     s'interromp la impressio d'una TS per mostrar    */
/*                     el contingut d'una TS d'un ambit encaixat.       */
/*                                                                      */
/*  Autors: Sergio Blanco Cuaresma                                      */
/*          Francisco Jose Aguilar Celdran                              */
/*                                                                      */
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "taula.h"
#include "print_ts.h"
#include "comuns.h"

Taula_Simbols *taulaSimbolActual, *taulaSimbolPrincipal;

void tractar_dades_funcio(char *nom_simbol, char *str_ambit, Info_Function *funcio_actual, FILE *output);
void tractar_dades_procediment(char *nom_simbol, char *str_ambit, Info_Procedure *proc_actual, FILE *output);
void mostrar_procedencia(Taula_Simbols *t, char* str_ambit, FILE *output);

void print_taula_simbols (FILE *output, Taula_Simbols *ts, char *str_ambit, int tipus_taula_simbols, int id_sobrecarrega) {
	int i;
	char aux[256];
	char ambit_aux[256];
	Simbol* simbol_derivat;
	
	if(ts != NULL)
	{
	if(tipus_taula_simbols == 0) {
		fprintf (output, "%s------",str_ambit);
		for(i = 0; i < strlen(ts -> nom); i++) {
			fprintf (output, "-");
		}
		
		if (id_sobrecarrega != 0) {
			fprintf (output, "-----------------");
			fprintf (output, "\n%sAmbit %s (sobrecarrega %d)\n",str_ambit,ts -> nom, id_sobrecarrega);
		} else {
			fprintf (output, "\n%sAmbit %s\n",str_ambit,ts -> nom);
		}
		fprintf (output, "%s------",str_ambit);
		for(i = 0; i < strlen(ts -> nom); i++) {
			fprintf (output, "-");
		}
		if (id_sobrecarrega != 0) {
			fprintf (output, "-----------------");
		}
		fprintf (output, "\n");
		
		Simbol *simbol_taula = busca_totes_taules(ts,ts -> nom);
		if(simbol_taula != NULL) {
			Tipus_Simbol tipus_taula = simbol_taula -> atributs.tipus;
			char ambit_aux[STRING_LENGTH];
			sprintf(ambit_aux,"%s# ",str_ambit);
			if(tipus_taula == PROCEDURE) {
				if(strcmp(simbol_taula -> atributs.continguts.info_procedure.nom_unic,"") != 0) {
					fprintf (output, "%s# Nom Complet: %s\n",str_ambit,simbol_taula -> atributs.continguts.info_procedure.nom_unic);
					mostrar_procedencia(ts,ambit_aux,output);
					fprintf(output,"\n");
				}
			}
			else if(tipus_taula == FUNCTION) {
				if(strcmp(simbol_taula -> atributs.continguts.info_function.nom_unic,"") != 0) {
					fprintf (output, "%s# Nom Complet: %s\n",str_ambit,simbol_taula -> atributs.continguts.info_function.nom_unic);		
					mostrar_procedencia(ts,ambit_aux,output);
					fprintf(output,"\n");
				}
			}
		}
	}
	
	for (i = 0; i < TAM_TAULA_SIMBOLS; i++) {
		if (ts->taula[i] != NULL) {
			// Fem una copia de la cua per evitar problemes amb el PDI (modificat per la funcio buscar_totes_taules)
			Cua colisions_copia;
			memcpy(&colisions_copia, ts -> taula[i], sizeof(Cua));
			Cua *colisions = &colisions_copia;
			//Cua *colisions = ts -> taula[i];
			reiniciar_PDI(colisions);
			Simbol *simbol = (Simbol *)obtenir_element_PDI(colisions);
			while(simbol != NULL) {

				// EL SIMBOL ES UNA VARIABLE
				
				if (simbol->atributs.tipus == VARIABLE) {
					switch (simbol->atributs.continguts.info_variable.tipus) {
					
						case TIPUS_INTEGER:
							if(simbol -> atributs.continguts.info_variable.inicialitzat == TRUE) {
								fprintf (output, "%sVariable INTEGER :: nom = %s, valor = %i", str_ambit, simbol->nom, simbol->atributs.continguts.info_variable.valor.integer);
							} else {
								fprintf (output, "%sVariable INTEGER :: nom = %s, valor = (no inicialitzat)", str_ambit, simbol->nom);
							}
							if(simbol -> atributs.continguts.info_variable.constant == TRUE) {
								fprintf (output, " (es una constant) ");
							}
							fprintf(output,"\n");
							break;
							
						case TIPUS_FLOAT:
							if(simbol -> atributs.continguts.info_variable.inicialitzat == TRUE) {
								fprintf (output, "%sVariable FLOAT :: nom = %s, valor = %g", str_ambit, simbol->nom, simbol->atributs.continguts.info_variable.valor.vfloat);
							} else {
								fprintf (output, "%sVariable FLOAT :: nom = %s, valor = (no inicialitzat)", str_ambit, simbol->nom);
							}
							if(simbol -> atributs.continguts.info_variable.constant == TRUE) {
								fprintf (output, " (es una constant) ");
							}
							fprintf (output,"\n");
							break;
						
						case TIPUS_BOOLEAN:
							if(simbol -> atributs.continguts.info_variable.inicialitzat == TRUE) {
								fprintf (output, "%sVariable BOOLEAN :: nom = %s, valor = %s", str_ambit, simbol->nom, simbol->atributs.continguts.info_variable.valor.boolean?"TRUE":"FALSE");
							} else {
								fprintf (output, "%sVariable BOOLEAN :: nom = %s, valor = (no inicialitzat)", str_ambit, simbol->nom);
							}
							if(simbol -> atributs.continguts.info_variable.constant == TRUE) {
								fprintf (output, " (es una constant) ");
							}							
							fprintf (output,"\n");
							break;
						
						case TIPUS_CHARACTER:
							if(simbol -> atributs.continguts.info_variable.inicialitzat == TRUE) {
								fprintf (output, "%sVariable CHARACTER :: nom = %s, valor = %c", str_ambit, simbol->nom, simbol->atributs.continguts.info_variable.valor.character);
							} else {
								fprintf (output, "%sVariable CHARACTER :: nom = %s, valor = (no inicialitzat)", str_ambit, simbol->nom);
							}
							if(simbol -> atributs.continguts.info_variable.constant == TRUE) {
								fprintf (output, " (es una constant) ");
							}
							fprintf (output,"\n");
							break;
						
						case TIPUS_STRING:
							if(simbol -> atributs.continguts.info_variable.inicialitzat == TRUE) {
								memset (aux,0,sizeof(aux));
								memcpy (aux,simbol->atributs.continguts.info_variable.valor.string+1, (unsigned char)(simbol->atributs.continguts.info_variable.valor.string[0]));							
								fprintf (output, "%sVariable STRING :: nom = %s, tamany='%d', valor = '%s'", str_ambit, simbol->nom, (unsigned char)(simbol->atributs.continguts.info_variable.valor.string[0]), aux);
							} else {
								fprintf (output, "%sVariable STRING :: nom = %s, valor = (no inicialitzat)", str_ambit, simbol->nom);
							}
							if(simbol -> atributs.continguts.info_variable.constant == TRUE) {
								fprintf (output, " (es una constant) ");
							}
							fprintf (output,"\n");
							break;

						case TIPUS_INTEGER_DERIVAT:
							if(simbol -> atributs.continguts.info_variable.inicialitzat == TRUE) {							
								fprintf (output, "%sVariable INTEGER_DERIVAT :: nom = %s, tipus = %s, valor = '%i'", str_ambit, simbol->nom, simbol->atributs.continguts.info_variable.nom_tipus, simbol->atributs.continguts.info_variable.valor.integer);
							} else {
								fprintf (output, "%sVariable INTEGER_DERIVAT :: nom = %s, tipus = %s, valor = (no inicialitzat)", str_ambit, simbol->nom, simbol->atributs.continguts.info_variable.nom_tipus);
							}
							if(simbol -> atributs.continguts.info_variable.constant == TRUE) {
								fprintf (output, " (es una constant) ");
							}
							fprintf (output,"\n");
							break;

						case TIPUS_DERIVAT:
							simbol_derivat = busca_totes_taules(ts, simbol->atributs.continguts.info_variable.nom_tipus);
							if(simbol_derivat != NULL)
							{
								Tipus_Simbol tipus_simbol = simbol_derivat -> atributs.tipus;
								char categoria_simbol[15];
								char *nom_tipus_derivat;
								int pos_enumerat = 0;
								switch(tipus_simbol)
								{
									case RECORD_TYPE:
										sprintf(categoria_simbol,"%s","record");
										break;	
									case ARRAY_TYPE:
										sprintf(categoria_simbol,"%s","array");
										break;
									case ENUMERATED_TYPE:
										sprintf(categoria_simbol,"%s","enumerated");
										// Impressio del valor de la variable enumerat
										if(simbol -> atributs.continguts.info_variable.inicialitzat == TRUE) {
											pos_enumerat = simbol -> atributs.continguts.info_variable.valor.integer;
											nom_tipus_derivat = simbol -> atributs.continguts.info_variable.nom_tipus;
											Simbol *simbol_enum = (Simbol *)busca_totes_taules(ts, nom_tipus_derivat);
											if(simbol_enum != NULL) {
												Cua *elements_enum = simbol_enum -> atributs.continguts.info_enumerated.elements;
												if(elements_enum != NULL) {
													reiniciar_PDI(elements_enum);
													char *valor;
													
													Simbol *valor_enum = (Simbol *)obtenir_element_PDI(elements_enum);
													valor = valor_enum -> nom;
													int comptador = 0;
													while(valor != NULL && comptador <= pos_enumerat) {
														seguent_PDI(elements_enum);
														valor_enum = (Simbol *)obtenir_element_PDI(elements_enum);
														valor = valor_enum -> nom;
														comptador++;
													}
													sprintf(categoria_simbol,"%s, valor = %s, posicio = %d",categoria_simbol,valor,pos_enumerat);
												}
											}
										}										
										break;
									case TYPE:
										sprintf(categoria_simbol,"%s","type");
										break;
									default:
										sprintf(categoria_simbol,"%s","");
								}
								if(strcmp(categoria_simbol,"") == 0) {
									fprintf (output,"%sEl tipus no pot ser identificat per a la variable: %s\n", str_ambit, simbol -> nom);
								} else {
									fprintf (output, "%sVariable TIPUS DERIVAT :: nom = %s, tipus = %s, categoria de tipus: %s" , str_ambit, simbol->nom, simbol->atributs.continguts.info_variable.nom_tipus,categoria_simbol);		
								}
							}						
							//if(simbol -> atributs.continguts.info_variable.inicialitzat == FALSE) {
							//	fprintf (output, " (valor no inicialitzat) ");
							//}
							if(simbol -> atributs.continguts.info_variable.constant == TRUE) {
								fprintf (output, " (es una constant) ");
							}
							fprintf (output,"\n");
							break;

						default: 
							fprintf (output,"%sEl tipus no pot ser identificat per a la variable: %s\n", str_ambit, simbol -> nom);
					}
				}
				
				// EL SIMBOL ES UN TIPUS DE CATEGORIA TYPE
				
				else if (simbol->atributs.tipus == TYPE) {
					switch (simbol->atributs.continguts.info_type.tipus) {
						case TIPUS_INTEGER:
							fprintf (output, "%sTipus INTEGER :: nom = %s\n", str_ambit, simbol->nom);
							break;
						case TIPUS_FLOAT:
							fprintf (output, "%sTipus FLOAT :: nom = %s\n", str_ambit, simbol->nom);
							break;
						case TIPUS_BOOLEAN:
							fprintf (output, "%sTipus BOOLEAN :: nom = %s\n", str_ambit, simbol->nom);
							break;
						case TIPUS_CHARACTER:
							fprintf (output, "%sTipus CHARACTER :: nom = %s\n", str_ambit, simbol->nom);
							break;
						case TIPUS_STRING:
							fprintf (output, "%sTipus STRING :: nom = %s\n", str_ambit, simbol->nom);
							break;
						case TIPUS_INTEGER_DERIVAT:
							fprintf (output, "%sTipus INTEGER_DERIVAT :: nom = %s\n", str_ambit, simbol->nom);
							fprintf (output, "%sRang del tipus integer derivat %s : Minim = %i, Maxim = %i", str_ambit, simbol -> nom, (int)simbol -> atributs.continguts.info_type.rang.min, (int)simbol -> atributs.continguts.info_array.rang.max);
							Tipus_Dades tipus_derivat = simbol -> atributs.continguts.info_array.rang.tipus;
							char nom_tipus_derivat[15];
							switch(tipus_derivat)
							{
								case TIPUS_INTEGER:
									sprintf(nom_tipus_derivat,"%s",", Tipus = integer");
									break;
								case TIPUS_FLOAT:
									sprintf(nom_tipus_derivat,"%s",", Tipus = float");
									break;
								case TIPUS_BOOLEAN:
									sprintf(nom_tipus_derivat,"%s",", Tipus = boolean");
									break;
								case TIPUS_CHARACTER:
									sprintf(nom_tipus_derivat,"%s",", Tipus = character");
									break;
								case TIPUS_STRING:
									sprintf(nom_tipus_derivat,"%s",", Tipus = string");
									break;
								case TIPUS_DERIVAT:
									sprintf(nom_tipus_derivat,"%s",", Tipus = derivat");
									break;
							}
							fprintf (output,"%s",nom_tipus_derivat);
							fprintf (output, "\n");
							break;
					}
					//fprintf (output, "\n");
				}				
				
				// EL SIMBOL ES UN TIPUS DE CATEGORIA RECORD_TYPE
				
				else if (simbol->atributs.tipus == RECORD_TYPE) {
					fprintf (output, "%sTipus RECORD :: nom = %s\n", str_ambit,simbol->nom);
					fprintf (output, "%sElements del record %s: \n",str_ambit,simbol->nom);
					sprintf(ambit_aux,"%s    ",str_ambit);
					print_taula_simbols (output, simbol -> atributs.continguts.info_record.elements,ambit_aux,1,0);
					fprintf (output, "%sFi dels elements del record %s \n",str_ambit,simbol->nom);
					//fprintf (output, "\t--------------------------------------------------------------------\n");

					fprintf (output, "\n");
				}
				
				// EL SIMBOL ES UN TIPUS DE CATEGORIA ARRAY_TYPE
				
				else if (simbol->atributs.tipus == ARRAY_TYPE) {
					//fprintf (output, "\tTipus ARRAY :: nom = %s, tipus = %s", simbol -> nom, simbol -> atributs.continguts.info_array.tipus);
					fprintf (output, "%sTipus ARRAY :: nom = %s\n", str_ambit,simbol -> nom); //FALTA MOSTRAR EL TIPUS DE L'ARRAY (COMPROVAR QUE NO PETI)
					fprintf (output, "%sRang de l'array %s : Minim = %f, Maxim = %f", str_ambit, simbol -> nom, simbol -> atributs.continguts.info_array.rang.min, simbol -> atributs.continguts.info_array.rang.max);
					Tipus_Dades tipus_array = simbol -> atributs.continguts.info_array.rang.tipus;
					char nom_tipus_array[15];
					switch(tipus_array)
					{
						case TIPUS_INTEGER:
							sprintf(nom_tipus_array,"%s",", Tipus = integer");
							break;
						case TIPUS_FLOAT:
							sprintf(nom_tipus_array,"%s",", Tipus = float");
							break;
						case TIPUS_BOOLEAN:
							sprintf(nom_tipus_array,"%s",", Tipus = boolean");
							break;
						case TIPUS_CHARACTER:
							sprintf(nom_tipus_array,"%s",", Tipus = character");
							break;
						case TIPUS_STRING:
							sprintf(nom_tipus_array,"%s",", Tipus = string");
							break;
						case TIPUS_DERIVAT:
							sprintf(nom_tipus_array,"%s",", Tipus = derivat");
							break;
					}
					fprintf (output,"%s",nom_tipus_array);
					fprintf (output, "\n");
				}
				
				// EL SIMBOL ES UN TIPUS DE CATEGORIA ENUMERATED_TYPE
				
				else if (simbol->atributs.tipus == ENUMERATED_TYPE) 
				{
					fprintf (output, "%sTipus ENUMERATED :: nom = %s\n", str_ambit, simbol->nom);
					fprintf (output, "%sElements de l'enumerat %s: \n", str_ambit, simbol->nom);
					Cua *cua_elements = simbol -> atributs.continguts.info_enumerated.elements;
					reiniciar_PDI(cua_elements);
					Simbol *element = (Simbol *)obtenir_element_PDI(cua_elements);
					while (element != NULL) {
						fprintf (output, "%s    nom: %s, valor: %d \n", str_ambit, element -> nom, element -> atributs.continguts.info_variable.valor.integer);
						seguent_PDI(cua_elements);
						element = (Simbol *)obtenir_element_PDI(cua_elements);
					}
					fprintf (output, "%sFi dels elements de l'enumerat %s \n", str_ambit, simbol->nom);
					//fprintf (output, "\t--------------------------------------------------------------------\n");
				}
										
				// EL SIMBOL ES UN PROCEDIMENT
				
				else if (simbol->atributs.tipus == PROCEDURE) {
					tractar_dades_procediment(simbol->nom,str_ambit,&(simbol -> atributs.continguts.info_procedure),output);
					
					int num_sobrecarregues = simbol->atributs.continguts.info_procedure.num_sobrecarregues;
					if (num_sobrecarregues != 0) {
						fprintf (output, "%sEl procediment %s te %d sobrecarregues: \n",str_ambit, simbol->nom, num_sobrecarregues);
						sprintf(ambit_aux,"%s    ",str_ambit);
						
						Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_procedure.sobrecarregues;
						reiniciar_PDI(cua_sobrecarregues);
						Info_Procedure *proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
												
						while (proc_actual != NULL) {
							tractar_dades_procediment(simbol->nom,ambit_aux,proc_actual,output);
							seguent_PDI(cua_sobrecarregues);
							proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
						}
						fprintf (output, "%sFi de sobrecarregues del procediment %s\n",str_ambit, simbol->nom);
					}					
					//fprintf (output, "\n");	
				}
	
				// EL SIMBOL ES UNA FUNCIO
			
				else if (simbol->atributs.tipus == FUNCTION){
					tractar_dades_funcio(simbol->nom,str_ambit,&(simbol -> atributs.continguts.info_function),output);
					
					int num_sobrecarregues = simbol->atributs.continguts.info_function.num_sobrecarregues;
					if (num_sobrecarregues != 0) {
						fprintf (output, "%sLa funcio %s te %d sobrecarregues: \n",str_ambit, simbol->nom, num_sobrecarregues);
						sprintf(ambit_aux,"%s    ",str_ambit);
						
						Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_function.sobrecarregues;
						reiniciar_PDI(cua_sobrecarregues);
						Info_Function *funcio_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
												
						while (funcio_actual != NULL) {
							tractar_dades_funcio(simbol->nom,ambit_aux,funcio_actual,output);
							seguent_PDI(cua_sobrecarregues);
							funcio_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
						}
						fprintf (output, "%sFi de sobrecarregues de la funcio %s\n",str_ambit, simbol->nom);
					}					
					//fprintf (output, "\n");				
				}
																		
				seguent_PDI(colisions);
				simbol = (Simbol *)obtenir_element_PDI(colisions);
			}
		}
	}

	for (i = 0; i < TAM_TAULA_SIMBOLS; i++) {
		if (ts->taula[i] != NULL) {
			Cua *colisions = ts -> taula[i];
			reiniciar_PDI(colisions);
			Simbol *simbol = (Simbol *)obtenir_element_PDI(colisions);
			while(simbol != NULL) {

				// EL SIMBOL ES UN PROCEDIMENT
				
				if (simbol->atributs.tipus == PROCEDURE) {
					sprintf(ambit_aux,"%s    ",str_ambit);
					
					print_taula_simbols (output, simbol -> atributs.continguts.info_function.taula,ambit_aux,0,0);
					fprintf (output, "\n");
					
					int num_sobrecarregues = simbol->atributs.continguts.info_procedure.num_sobrecarregues;
					if (num_sobrecarregues != 0) {
						Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_procedure.sobrecarregues;
						reiniciar_PDI(cua_sobrecarregues);
						Info_Procedure *proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
												
						while (proc_actual != NULL) {
							print_taula_simbols (output, proc_actual -> taula,ambit_aux,0, proc_actual -> id);
							fprintf (output, "\n");
							
							seguent_PDI(cua_sobrecarregues);
							proc_actual = (Info_Procedure *)obtenir_element_PDI(cua_sobrecarregues);
						}
					}
				}
	
				// EL SIMBOL ES UNA FUNCIO
			
				if (simbol->atributs.tipus == FUNCTION){
					sprintf(ambit_aux,"%s    ",str_ambit);
						
					print_taula_simbols (output, simbol -> atributs.continguts.info_function.taula,ambit_aux,0,0);
					fprintf (output, "\n");
					
					int num_sobrecarregues = simbol->atributs.continguts.info_function.num_sobrecarregues;
					if (num_sobrecarregues != 0) {
						Cua *cua_sobrecarregues = simbol -> atributs.continguts.info_function.sobrecarregues;
						reiniciar_PDI(cua_sobrecarregues);
						Info_Function *proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
												
						while (proc_actual != NULL) {
							print_taula_simbols (output, proc_actual -> taula,ambit_aux,0,proc_actual -> id);
							fprintf (output, "\n");
							
							seguent_PDI(cua_sobrecarregues);
							proc_actual = (Info_Function *)obtenir_element_PDI(cua_sobrecarregues);
						}
					}				
				}
	
				seguent_PDI(colisions);
				simbol = (Simbol *)obtenir_element_PDI(colisions);
			}
		}
	}
	}
	else
	{
		fprintf (output, "\t Aquesta taula de simbols no te cap contingut.\n\n");	
	}
}

void tractar_dades_funcio(char *nom_simbol, char *str_ambit, Info_Function *funcio_actual, FILE *output)
{
	fprintf (output, "%sRutina FUNCTION :: nom = %s", str_ambit, nom_simbol);
	fprintf (output, ", num_parametres = %d",funcio_actual -> num_parametres);
	if(funcio_actual -> complet == FALSE) {
		fprintf (output, ", definicio de funcio = incompleta\n");
	} else	{
		fprintf (output, ", definicio de funcio = completa\n");
	}
	switch(funcio_actual -> tipus_retorn)
	{
		case TIPUS_INTEGER: fprintf (output, "%sValor de retorn de la funcio %s: tipus = integer\n",str_ambit,nom_simbol); break;
		case TIPUS_FLOAT: fprintf (output, "%sValor de retorn de la funcio %s: tipus = float\n",str_ambit,nom_simbol); break;
		case TIPUS_BOOLEAN: fprintf (output, "%sValor de retorn de la funcio %s: tipus = boolean\n",str_ambit,nom_simbol); break;
		case TIPUS_CHARACTER: fprintf (output, "%sValor de retorn de la funcio %s: tipus = character\n",str_ambit,nom_simbol); break;
		case TIPUS_STRING: fprintf (output, "%sValor de retorn de la funcio %s: tipus = string\n",str_ambit,nom_simbol); break;
		case TIPUS_DERIVAT: fprintf (output, "%sValor de retorn de la funcio %s: tipus = derivat\n",str_ambit,nom_simbol); break;
		case TIPUS_INTEGER_DERIVAT: fprintf (output, "%sValor de retorn de la funcio %s: tipus = integer_derivat, nom = %s\n",str_ambit,nom_simbol,funcio_actual -> nom_tipus_retorn); break;
	}
	if (funcio_actual -> num_parametres != 0) {
		fprintf (output, "%sParametres de la funcio %s: \n",str_ambit,nom_simbol);
			
		Cua *cua_parametres = funcio_actual -> parametres;
		reiniciar_PDI(cua_parametres);
		char *nom_element = (char *)obtenir_element_PDI(cua_parametres);
		while (nom_element != NULL) {
			Simbol *element = obtenir_simbol(funcio_actual -> taula, nom_element);
			char *nom_tipus_derivat;
			switch(element -> atributs.continguts.info_variable.tipus)
			{
				case TIPUS_INTEGER:	fprintf (output, "%s    nom: %s, tipus: integer \n", str_ambit, element -> nom); break;
				case TIPUS_FLOAT: fprintf (output, "%s    nom: %s, tipus: float \n", str_ambit, element -> nom); break;
				case TIPUS_BOOLEAN:	fprintf (output, "%s    nom: %s, tipus: boolean \n", str_ambit, element -> nom); break;
				case TIPUS_CHARACTER: fprintf (output, "%s    nom: %s, tipus: character \n", str_ambit, element -> nom); break;
				case TIPUS_STRING: fprintf (output, "%s    nom: %s, tipus: string \n", str_ambit, element -> nom); break;
				case TIPUS_DERIVAT:	
					nom_tipus_derivat = element -> atributs.continguts.info_variable.nom_tipus;
					fprintf (output, "%s    nom: %s, tipus: derivat nom tipus derivat: %s\n", str_ambit, element -> nom, nom_tipus_derivat); break;
				case TIPUS_INTEGER_DERIVAT:	fprintf (output, "%s    nom: %s, tipus: integer_derivat \n", str_ambit, element -> nom); break;
			}
			seguent_PDI(cua_parametres);
			nom_element = (char *)obtenir_element_PDI(cua_parametres);
		}
		fprintf (output, "%sFi dels parametres de la funcio %s\n",str_ambit,nom_simbol);
	} else {
		fprintf (output, "%sLa funcio %s no te parametres\n",str_ambit,nom_simbol);
	}
}

void tractar_dades_procediment(char *nom_simbol, char *str_ambit, Info_Procedure *proc_actual, FILE *output)
{
	fprintf (output, "%sRutina PROCEDURE :: nom = %s", str_ambit, nom_simbol);
	fprintf (output, ", num_parametres = %d",proc_actual -> num_parametres);
	if(proc_actual -> complet == FALSE) {
		fprintf (output, ", definicio de procediment = incompleta\n");
	} else	{
		fprintf (output, ", definicio de procediment = completa\n");
	}
	if (proc_actual -> num_parametres != 0) {
		fprintf (output, "%sParametres del procediment %s: \n",str_ambit,nom_simbol);
			
		Cua *cua_parametres = proc_actual -> parametres;
		reiniciar_PDI(cua_parametres);
		char *nom_element = (char *)obtenir_element_PDI(cua_parametres);
		while (nom_element != NULL) {
			Simbol *element = obtenir_simbol(proc_actual -> taula, nom_element);
			char *nom_tipus_derivat;
			switch(element -> atributs.continguts.info_variable.tipus)
			{
				case TIPUS_INTEGER:	fprintf (output, "%s    nom: %s, tipus: integer \n", str_ambit, element -> nom); break;
				case TIPUS_FLOAT: fprintf (output, "%s    nom: %s, tipus: float \n", str_ambit, element -> nom); break;
				case TIPUS_BOOLEAN:	fprintf (output, "%s    nom: %s, tipus: boolean \n", str_ambit, element -> nom); break;
				case TIPUS_CHARACTER: fprintf (output, "%s    nom: %s, tipus: character \n", str_ambit, element -> nom); break;
				case TIPUS_STRING: fprintf (output, "%s    nom: %s, tipus: string \n", str_ambit, element -> nom); break;
				case TIPUS_DERIVAT:	
					nom_tipus_derivat = element -> atributs.continguts.info_variable.nom_tipus;
					fprintf (output, "%s    nom: %s, tipus: derivat nom tipus derivat: %s\n", str_ambit, element -> nom, nom_tipus_derivat); break;
				case TIPUS_INTEGER_DERIVAT:	fprintf (output, "%s    nom: %s, tipus: integer_derivat \n", str_ambit, element -> nom); break;
			}
			seguent_PDI(cua_parametres);
			nom_element = (char *)obtenir_element_PDI(cua_parametres);
		}
		fprintf (output, "%sFi dels parametres del procediment %s\n",str_ambit,nom_simbol);
	} else {
		fprintf (output, "%sEl procediment %s no te parametres\n",str_ambit,nom_simbol);
	}
}

